Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/IOperator.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/IOperator.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/IOperator.cs	(revision 15554)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Joseph Helm and Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.BinPacking3D.Encoding;
+using HeuristicLab.Problems.BinPacking3D.Evaluators;
+
+namespace HeuristicLab.Problems.BinPacking3D {
+  public interface IOperator<TSol> : IItem {
+    ILookupParameter<ReadOnlyItemList<PackingItem>> ItemsParameter { get; }
+    ILookupParameter<PackingShape> BinShapeParameter { get; }
+    ILookupParameter<IDecoder<TSol>> DecoderParameter { get; }
+    ILookupParameter<IEvaluator> SolutionEvaluatorParameter { get; }
+    ILookupParameter<BoolValue> UseStackingConstraintsParameter { get; }
+  }
+}
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPacker.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPacker.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPacker.cs	(revision 15554)
@@ -33,12 +33,6 @@
 
 namespace HeuristicLab.Problems.BinPacking3D.Packer {
-  public abstract class BinPacker : Item {
-
-    /*
-    [Storable]
-    IPositionFinder PositionFinder
+  internal abstract class BinPacker : Item, IBinPacker {
     
-    */
-
     #region Constructors for HEAL
 
@@ -49,5 +43,4 @@
     protected BinPacker(BinPacker original, Cloner cloner) 
       : base(original, cloner) {
-      //this.PositionFinder = original.PositionFinder;
     }
 
@@ -99,5 +92,7 @@
 
       // The extremepoints are sortet by Y / Z / X
-      return packingBin.ExtremePoints.Where(x => packingBin.IsPositionFeasible(newItem, x, useStackingConstraints)).FirstOrDefault();
+      var newPosition = packingBin.ExtremePoints.Where(x => packingBin.IsPositionFeasible(newItem, x.Key, useStackingConstraints)).FirstOrDefault();
+     
+      return newPosition.Key;
     }
 
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFactory.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFactory.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFactory.cs	(revision 15554)
@@ -17,6 +17,6 @@
     /// <param name="fittingMethod"></param>
     /// <returns>Returns a new BinPacker depending on the given fitting method</returns>
-    public static BinPacker CreateBinPacker(FittingMethod fittingMethod) {
-      BinPacker binPacker = null;
+    public static IBinPacker CreateBinPacker(FittingMethod fittingMethod) {
+      IBinPacker binPacker = null;
       switch (fittingMethod) {
         case FittingMethod.FirstFit:
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFirstFit.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFirstFit.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFirstFit.cs	(revision 15554)
@@ -32,5 +32,5 @@
 
 namespace HeuristicLab.Problems.BinPacking3D.Packer {
-  public class BinPackerFirstFit : BinPacker {
+  internal class BinPackerFirstFit : BinPacker {
     #region Constructors for HEAL
     [StorableConstructor]
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFreeVolumeBestFit.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFreeVolumeBestFit.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerFreeVolumeBestFit.cs	(revision 15554)
@@ -32,5 +32,5 @@
 
 namespace HeuristicLab.Problems.BinPacking3D.Packer {
-  public class BinPackerFreeVolumeBestFit : BinPacker {
+  internal class BinPackerFreeVolumeBestFit : BinPacker {
     
     #region Constructors for HEAL
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerResidualSpaceBestFit.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerResidualSpaceBestFit.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/BinPackerResidualSpaceBestFit.cs	(revision 15554)
@@ -32,5 +32,5 @@
 
 namespace HeuristicLab.Problems.BinPacking3D.Packer {
-  public class BinPackerResidualSpaceBestFit : BinPacker {
+  internal class BinPackerResidualSpaceBestFit : BinPacker {
 
     #region Constructors for HEAL
@@ -55,8 +55,8 @@
     /// </summary>
     /// <returns>Returns a collection of bin packing 3d objects. Each object represents a bin and the packed items</returns>
-    public override IList<BinPacking3D> PackItems(Permutation sortedItems, PackingShape binShape, IList<PackingItem> items, ExtremePointCreationMethod epGenerationMethod, bool useStackingConstraints) {
+    public override IList<BinPacking3D> PackItems(Permutation sortedItems, PackingShape binShape, IList<PackingItem> items, ExtremePointCreationMethod epCreationMethod, bool useStackingConstraints) {
       IList<BinPacking3D> packingList = new List<BinPacking3D>();
       IList<int> remainingIds = new List<int>(sortedItems);
-      IExtremePointCreator extremePointCreator = ExtremePointCreatorFactory.CreateExtremePointCreator(epGenerationMethod, useStackingConstraints);
+      IExtremePointCreator extremePointCreator = ExtremePointCreatorFactory.CreateExtremePointCreator(epCreationMethod, useStackingConstraints);
       bool rotated = false;
 
@@ -100,10 +100,12 @@
       var residualSpacePoints = new List<Tuple<BinPacking3D, PackingPosition, int>>();
       foreach (BinPacking3D bp in packingList) {
-        foreach (var ep in bp.ExtremePoints) {
-          var rs = bp.ResidualSpaces[ep];
-          if (rs.Width < item.Width || rs.Height < item.Height || rs.Depth < item.Depth) {
+        foreach (var extremPoints in bp.ExtremePoints) {
+          var ep = extremPoints.Key;
+          var residualSpaces = extremPoints.Value.Where(rs => rs.Width < item.Width || rs.Height < item.Height || rs.Depth < item.Depth);
+          if (residualSpaces.Count() <= 0) {
             continue;
           }
-          residualSpacePoints.Add(Tuple.Create(bp, ep, CalculateResidualMerit(rs, item, ep)));
+          int merit = residualSpaces.Max(rs => CalculateResidualMerit(rs, item, ep));
+          residualSpacePoints.Add(Tuple.Create(bp, ep, merit));
         }
       }
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/IBinPacker.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/IBinPacker.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/Packer/IBinPacker.cs	(revision 15554)
@@ -0,0 +1,21 @@
+﻿using HeuristicLab.Encodings.PermutationEncoding;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Problems.BinPacking3D.Packer {
+  public interface IBinPacker {
+    /// <summary>
+    /// Packs all items of the bin packer and returns a collection of BinPacking3D objects
+    /// </summary>
+    /// <param name="sortedItems">Permutation of items sorted by a sorting method. The value of each permutation index references to the index of the items list</param>
+    /// <param name="binShape">Bin for storing the items</param>
+    /// <param name="items">A list of packing items which should be assigned to a bin</param>
+    /// <param name="useStackingConstraints">Flag for using stacking constraints</param>
+    /// <returns>Returns a collection of bin packing 3d objects. Each object represents a bin and the packed items</returns>
+    IList<BinPacking3D> PackItems(Permutation sortedItems, PackingShape binShape, IList<PackingItem> items, ExtremePointCreationMethod epCreationMethod, bool useStackingConstraints);
+
+  }
+}
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/PackingPosition.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/PackingPosition.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/PackingPosition.cs	(revision 15554)
@@ -75,30 +75,5 @@
       return base.GetHashCode() + 13 * X + 17 * Y + 23 * Z;
     }
-
-    [Obsolete]
-    public static PackingPosition MoveLeft(PackingPosition original) {
-      return new PackingPosition(original.AssignedBin, original.X - 1, original.Y, original.Z, original.Rotated);
-    }
-    [Obsolete]
-    public static PackingPosition MoveDown(PackingPosition original) {
-      return new PackingPosition(original.AssignedBin, original.X, original.Y - 1, original.Z, original.Rotated);
-    }
-    [Obsolete]
-    public static PackingPosition MoveBack(PackingPosition original) {
-      return new PackingPosition(original.AssignedBin, original.X, original.Y, original.Z - 1, original.Rotated);
-    }
-    [Obsolete]
-    public static PackingPosition MoveRight(PackingPosition original) {
-      return new PackingPosition(original.AssignedBin, original.X + 1, original.Y, original.Z, original.Rotated);
-    }
-    [Obsolete]
-    public static PackingPosition MoveUp(PackingPosition original) {
-      return new PackingPosition(original.AssignedBin, original.X, original.Y + 1, original.Z, original.Rotated);
-    }
-    [Obsolete]
-    public static PackingPosition MoveFront(PackingPosition original) {
-      return new PackingPosition(original.AssignedBin, original.X, original.Y, original.Z + 1, original.Rotated);
-    }
-
+    
     #region IComparable<PackingPosition> Members
 
@@ -115,13 +90,5 @@
       if (result == 0)
         result = X.CompareTo(other.X);
-      /*
-      int result = Z.CompareTo(other.Z);
-      if (result == 0)
-        result = X.CompareTo(other.X);
-      if (result == 0)
-        result = Y.CompareTo(other.Y);
-      */
       return result;
-
     }
 
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ResidualSpaceCalculation/IResidualSpaceCalculator.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ResidualSpaceCalculation/IResidualSpaceCalculator.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ResidualSpaceCalculation/IResidualSpaceCalculator.cs	(revision 15554)
@@ -11,4 +11,5 @@
     /// <summary>
     /// Calculates all available residual spaces for a given point and returns them packed in a collection.
+    /// The returned collection has zero elements if the residual space is zero
     /// </summary>
     /// <param name="binPacking"></param>
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ResidualSpaceCalculation/ResidualSpaceCalculator.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ResidualSpaceCalculation/ResidualSpaceCalculator.cs	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/3D/ResidualSpaceCalculation/ResidualSpaceCalculator.cs	(revision 15554)
@@ -10,5 +10,5 @@
 
     internal ResidualSpaceCalculator() {}
-
+    
     public IEnumerable<ResidualSpace> CalculateResidualSpaces(BinPacking3D binPacking, Vector3D point) {
       IList<ResidualSpace> residualSpaces = new List<ResidualSpace>();
@@ -17,11 +17,13 @@
       var rs3 = CalculateYXZ(binPacking, point);
 
-      residualSpaces.Add(rs1);
-
-
-      if (!residualSpaces.Any(rs => rs.Equals(rs2))) {
+      if (!rs1.IsZero()) {
+        residualSpaces.Add(rs1);
+      }     
+
+
+      if (!rs2.IsZero() && !residualSpaces.Any(rs => rs.Equals(rs2))) {
         residualSpaces.Add(rs2);
       }
-      if (!residualSpaces.Any(rs => rs.Equals(rs3))) {
+      if (!rs3.IsZero() && !residualSpaces.Any(rs => rs.Equals(rs3))) {
         residualSpaces.Add(rs3);
       }
@@ -56,4 +58,12 @@
     }
     
+    /// <summary>
+    /// Returnst true if a given residual space and item overlaps at the x-axis
+    /// </summary>
+    /// <param name="point"></param>
+    /// <param name="residualSpace"></param>
+    /// <param name="position"></param>
+    /// <param name="item"></param>
+    /// <returns></returns>
     private bool OverlapsX(Vector3D point, ResidualSpace residualSpace, PackingPosition position, PackingItem item) {
       if (point.X > position.X && point.X >= position.X + item.Width) {
@@ -66,5 +76,12 @@
       return true;
     }
-    
+
+    /// <summary>
+    /// Returnst true if a given residual space and item overlaps at the y-axis
+    /// </summary>
+    /// <param name="point"></param>
+    /// <param name="residualSpace"></param>
+    /// <param name="position"></param>
+    /// <param name="item"></param>
     private bool OverlapsY(Vector3D point, ResidualSpace residualSpace, PackingPosition position, PackingItem item) {
       if (point.Y > position.Y && point.Y >= position.Y + item.Height) {
@@ -78,4 +95,11 @@
     }
 
+    /// <summary>
+    /// Returnst true if a given residual space and item overlaps at the z-axis
+    /// </summary>
+    /// <param name="point"></param>
+    /// <param name="residualSpace"></param>
+    /// <param name="position"></param>
+    /// <param name="item"></param>
     private bool OverlapsZ(Vector3D point, ResidualSpace residualSpace, PackingPosition position, PackingItem item) {
       if (point.Z > position.Z && point.Z >= position.Z + item.Depth) {
@@ -90,4 +114,5 @@
 
     private bool OverlapsOnRight(Vector3D point, ResidualSpace residualSpace, PackingPosition position, PackingItem item) {
+      // if point.x >= position.x, the residual space would be located on the left side!
       if (point.X >= position.X) {
         return false;
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 15553)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Problems.BinPacking/3.3/HeuristicLab.Problems.BinPacking-3.3.csproj	(revision 15554)
@@ -130,9 +130,10 @@
     <Compile Include="3D\Encoding\IDecoder.cs" />
     <Compile Include="3D\Evaluators\IEvaluator.cs" />
+    <Compile Include="3D\Packer\IBinPacker.cs" />
     <Compile Include="3D\ResidualSpace.cs" />
     <Compile Include="3D\ResidualSpaceCalculation\IResidualSpaceCalculator.cs" />
     <Compile Include="3D\ResidualSpaceCalculation\ResidualSpaceCalculator.cs" />
     <Compile Include="3D\ResidualSpaceCalculation\ResidualSpaceCalculatorFactory.cs" />
-    <Compile Include="3D\Sorting\IOperator.cs" />
+    <Compile Include="3D\IOperator.cs" />
     <Compile Include="3D\Evaluators\MoveEvaluatorBase.cs" />
     <Compile Include="3D\PackingItem.cs" />
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Algorithms/ExtremePointAlgorithmTest.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Algorithms/ExtremePointAlgorithmTest.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/Algorithms/ExtremePointAlgorithmTest.cs	(revision 15554)
@@ -0,0 +1,100 @@
+﻿using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.BinPacking3D;
+using System.Collections.Generic;
+
+using HeuristicLab.Problems.BinPacking._3D.Utils.Tests;
+using System.Threading;
+using System.Linq;
+
+namespace HeuristicLab.Problems.BinPacking._3D.Algorithms.Tests {
+  [TestClass]
+  public class ExtremePointAlgorithmTest {
+
+    private PackingShape _packingShape1;
+    private PackingShape _packingShape2;
+    private PackingShape _packingShape3;
+    private IList<PackingItem> _items;
+    private ExtremePointAlgorithm _extremPointAlgorithm;
+
+    [TestInitialize]
+    public void Initializes() {
+      _packingShape1 = new PackingShape(19, 19, 19);
+      _packingShape2 = new PackingShape(18, 18, 18);
+      _packingShape3 = new PackingShape(20, 20, 20);
+      _items = new List<PackingItem>();
+
+      _items.Add(new PackingItem(8, 10, 10, _packingShape1, 1000, 1)); // 0,  V = 800,  A =  80, h = 10
+      _items.Add(new PackingItem(10, 8, 10, _packingShape1, 1000, 2)); // 1,  V = 800,  A = 100, h =  8
+      _items.Add(new PackingItem(10, 10, 8, _packingShape1, 1000, 3)); // 2,  V = 800,  A =  80, h = 10
+      _items.Add(new PackingItem(8, 8, 10, _packingShape1, 1000, 4)); // 3,   V = 640,  A =  80, h =  8
+      _items.Add(new PackingItem(10, 8, 8, _packingShape1, 1000, 0)); // 4,   V = 640,  A =  80, h =  8
+      _items.Add(new PackingItem(8, 10, 8, _packingShape1, 1000, 1)); // 5,   V = 640,  A =  64, h = 10  
+      _items.Add(new PackingItem(8, 8, 8, _packingShape1, 1000, 2)); // 6,    V = 512,  A =  64, h =  8
+
+      _items.Add(new PackingItem(10, 10, 10, _packingShape1, 1000, 3)); // 7, V = 1000, A = 100, h = 10
+
+      _items.Add(new PackingItem(9, 10, 10, _packingShape1, 1000, 4)); // 8,  V = 900,  A =  90, h = 10
+      _items.Add(new PackingItem(10, 9, 10, _packingShape1, 1000, 0)); // 9,  V = 900,  A = 100, h =  9
+      _items.Add(new PackingItem(10, 10, 9, _packingShape1, 1000, 1)); // 10, V = 900,  A =  90, h = 10
+      _items.Add(new PackingItem(9, 9, 10, _packingShape1, 1000, 2)); // 11,  V = 810,  A =  90, h =  9
+      _items.Add(new PackingItem(10, 9, 9, _packingShape1, 1000, 3)); // 12,  V = 810,  A =  90, h =  9
+      _items.Add(new PackingItem(9, 10, 9, _packingShape1, 1000, 4)); // 13,  V = 810,  A =  81, h = 10
+      _items.Add(new PackingItem(9, 9, 9, _packingShape1, 1000, 0)); // 14,   V = 729,  A =  81, h =  9
+
+      _extremPointAlgorithm = new ExtremePointAlgorithm();
+    }
+
+
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "long")]
+    public void TestExtremePointAlgorithm() {
+       
+      IList<BinPacking3D.PackingPosition> positionsBin0 = new List<BinPacking3D.PackingPosition>() {
+        new BinPacking3D.PackingPosition(0, 0,0,0),
+        new BinPacking3D.PackingPosition(0, 8,0,0),
+        new BinPacking3D.PackingPosition(0, 0,0,10),
+        new BinPacking3D.PackingPosition(0, 10,0,10),
+        new BinPacking3D.PackingPosition(0, 8,8,0),
+        new BinPacking3D.PackingPosition(0, 0,10,0),
+        new BinPacking3D.PackingPosition(0, 0,10,8),
+        new BinPacking3D.PackingPosition(0, 8,10,8),
+      };
+
+      IList<BinPacking3D.PackingPosition> positionsBin1 = new List<BinPacking3D.PackingPosition>() {
+        new BinPacking3D.PackingPosition(1, 0,0,0),
+        new BinPacking3D.PackingPosition(1, 9,0,0),
+        new BinPacking3D.PackingPosition(1, 0,0,10),
+        new BinPacking3D.PackingPosition(1, 10,0,10),
+        new BinPacking3D.PackingPosition(1, 9,9,0),
+        new BinPacking3D.PackingPosition(1, 0,10,0),
+        new BinPacking3D.PackingPosition(1, 0,10,9)
+      };
+
+      object[] parameters = new object[] { _packingShape3, _items, new SortingMethod[] { SortingMethod.Given }, new FittingMethod[] { FittingMethod.FirstFit }, new CancellationToken() };
+      _extremPointAlgorithm.SortingMethodParameter.Value.Value = SortingMethod.Given;
+      _extremPointAlgorithm.FittingMethodParameter.Value.Value = FittingMethod.FirstFit;
+      _extremPointAlgorithm.ExtremePointCreationMethodParameter.Value.Value = ExtremePointCreationMethod.PointProjection;
+      _extremPointAlgorithm.SortByMaterialParameter.Value.Value = false;
+      var result = TestUtils.InvokeMethod(typeof(ExtremePointAlgorithm), _extremPointAlgorithm, "GetBest", parameters) as Tuple<Solution, double, SortingMethod?, FittingMethod?>;
+
+      int i = 0;
+      foreach (var item in result.Item1.Bins[0].Positions.Values) {
+        Assert.AreEqual(positionsBin0[i].X, item.X);
+        Assert.AreEqual(positionsBin0[i].Y, item.Y);
+        Assert.AreEqual(positionsBin0[i].Z, item.Z);
+        i++;
+      }
+
+      i = 0;
+      foreach (var item in result.Item1.Bins[1].Positions.Values) {
+        Assert.AreEqual(positionsBin1[i].X, item.X);
+        Assert.AreEqual(positionsBin1[i].Y, item.Y);
+        Assert.AreEqual(positionsBin1[i].Z, item.Z);
+        i++;
+      }
+    }
+  }
+}
Index: /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/ExtremePointCreation/TestLineProjectionBasedEPCreator.cs
===================================================================
--- /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/ExtremePointCreation/TestLineProjectionBasedEPCreator.cs	(revision 15554)
+++ /branches/2817-BinPackingSpeedup/HeuristicLab.Tests/HeuristicLab.Problems.Bin-Packing-3.3/3D/ExtremePointCreation/TestLineProjectionBasedEPCreator.cs	(revision 15554)
@@ -0,0 +1,126 @@
+﻿using System;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+using HeuristicLab.Problems.BinPacking3D.ExtremePointCreation;
+
+namespace HeuristicLab.Problems.BinPacking._3D.ExtremePointCreation.Tests {
+
+  [TestClass]
+  public class TestLineProjectionBasedEPCreator {
+
+    BinPacking3D.BinPacking3D _binPacking1;
+    BinPacking3D.BinPacking3D _binPacking2;
+    BinPacking3D.BinPacking3D _binPacking3;
+    BinPacking3D.BinPacking3D _binPacking4;
+
+    BinPacking3D.PackingItem _item1;
+    BinPacking3D.PackingItem _item2;
+    BinPacking3D.PackingItem _item3;
+    BinPacking3D.PackingItem _item4;
+
+    BinPacking3D.PackingPosition _pos1;
+    BinPacking3D.PackingPosition _pos2;
+    BinPacking3D.PackingPosition _pos3;
+    BinPacking3D.PackingPosition _pos4;
+
+    IExtremePointCreator _creator;
+
+    [TestInitialize]
+    public void Initialize() {
+      _creator = ExtremePointCreatorFactory.CreateExtremePointCreator(BinPacking3D.ExtremePointCreationMethod.LineProjection, false);
+      var packingShape = new BinPacking3D.PackingShape(20, 20, 20);
+      _item1 = new BinPacking3D.PackingItem(8, 4, 8, packingShape);
+      _item2 = new BinPacking3D.PackingItem(4, 10, 4, packingShape);
+      _item3 = new BinPacking3D.PackingItem(8, 8, 8, packingShape);
+      _item4 = new BinPacking3D.PackingItem(2, 2, 20, packingShape);
+
+      _pos1 = new BinPacking3D.PackingPosition(0, 0, 0, 0);
+      _pos2 = new BinPacking3D.PackingPosition(0, 8, 0, 0);
+      _pos3 = new BinPacking3D.PackingPosition(0, 12, 0, 0);
+      _pos4 = new BinPacking3D.PackingPosition(0, 0, 4, 0);
+
+      _binPacking1 = new BinPacking3D.BinPacking3D(packingShape);
+
+      _binPacking1.PackItem(0, _item1, _pos1);
+
+      _binPacking2 = _binPacking1.Clone() as BinPacking3D.BinPacking3D;
+      _binPacking2.PackItem(1, _item2, _pos2);
+
+      _binPacking3 = _binPacking2.Clone() as BinPacking3D.BinPacking3D;
+      _binPacking3.PackItem(2, _item3, _pos3);
+
+      _binPacking4 = _binPacking3.Clone() as BinPacking3D.BinPacking3D;
+      _binPacking4.PackItem(3, _item4, _pos4);
+
+      Assert.AreEqual(1, _binPacking1.Items.Count);
+      Assert.AreEqual(2, _binPacking2.Items.Count);
+      Assert.AreEqual(3, _binPacking3.Items.Count);
+      Assert.AreEqual(4, _binPacking4.Items.Count);
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestUpdateExtremePoints1() {
+
+      _creator.UpdateBinPacking(_binPacking1, _item1, _pos1);
+      Assert.AreEqual(3, _binPacking1.ExtremePoints.Count);
+      Assert.IsTrue(_binPacking1.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 8, 0, 0)));
+      Assert.IsTrue(_binPacking1.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 4, 0)));
+      Assert.IsTrue(_binPacking1.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 0, 8)));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestUpdateExtremePoints2() {
+      _creator.UpdateBinPacking(_binPacking2, _item2, _pos2);
+      Assert.AreEqual(7, _binPacking2.ExtremePoints.Count);
+      Assert.IsTrue(_binPacking2.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 12, 0, 0)));
+      Assert.IsTrue(_binPacking2.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 8, 0, 4)));
+      Assert.IsTrue(_binPacking2.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 0, 8)));
+      Assert.IsTrue(_binPacking2.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 4, 0)));
+      Assert.IsTrue(_binPacking2.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 4, 4)));
+      Assert.IsTrue(_binPacking2.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 10, 0)));
+      Assert.IsTrue(_binPacking2.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 8, 10, 0)));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestUpdateExtremePoints3() {
+      _creator.UpdateBinPacking(_binPacking3, _item3, _pos3);
+      Assert.AreEqual(8, _binPacking3.ExtremePoints.Count);
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 8, 0, 4)));
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 0, 8)));
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 4, 0)));
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 4, 4)));
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 12, 8, 0)));
+
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 8, 4)));
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 10, 0)));
+      Assert.IsTrue(_binPacking3.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 8, 10, 0)));
+    }
+
+    [TestMethod]
+    [TestCategory("Problems.BinPacking.3D")]
+    [TestProperty("Time", "short")]
+    public void TestUpdateExtremePoints4() {
+      _creator.UpdateBinPacking(_binPacking4, _item4, _pos4);
+      Assert.AreEqual(12, _binPacking4.ExtremePoints.Count);
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 8, 0, 4)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 0, 8)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 2, 0, 8)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 2, 4, 0)));
+
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 2, 4, 4)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 6, 0)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 6, 4)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 6, 8)));
+
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 12, 8, 0)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 8, 4)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 0, 10, 0)));
+      Assert.IsTrue(_binPacking4.ExtremePoints.ContainsKey(new BinPacking3D.PackingPosition(0, 8, 10, 0)));
+    }
+  }
+}
